﻿'
' Copyright (c) 2021, MindFusion LLC - Bulgaria.
'

Imports MindFusion.Diagramming.Wpf.Layout


''' <summary>
''' Interaction logic for MainWindow.xaml
''' </summary>
Partial Public Class MainWindow
	Inherits Window
	Public Sub New()
		InitializeComponent()
	End Sub

	Private Sub OnWindowLoaded(ByVal sender As Object, ByVal e As RoutedEventArgs)
		Dim root = diagram.Factory.CreateShapeNode(nodeBounds)
		root.Text = "Project"
		Dim document = XDocument.Load("SampleTree.xml")
		CreateChildren(root, document.Element("Project"))

		Dim layout = New TreeLayout()
		layout.Type = TreeLayoutType.Cascading
		layout.Direction = TreeLayoutDirections.LeftToRight
		layout.LinkStyle = TreeLayoutLinkType.Cascading2
		layout.NodeDistance = 5
		layout.LevelDistance = -25
		' let horizontal positions overlap
		layout.Arrange(diagram)
	End Sub

	Private Sub CreateChildren(ByVal parentDiagNode As DiagramNode, ByVal parentXmlElement As XElement)
		For Each element As XElement In parentXmlElement.Elements("Activity")
			Dim node = diagram.Factory.CreateShapeNode(nodeBounds)
			node.Text = element.Attribute("Name").Value
			diagram.Factory.CreateDiagramLink(parentDiagNode, node)
			CreateChildren(node, element)
		Next
	End Sub

	Private nodeBounds As New Rect(0, 0, 100, 22)
End Class